function [u,v] = getMax(I,i,j,np)

if(1) % improved fail-safe version
    ri = floor(i/np);
    rj = floor(j/np);
    sub = I(ri*np+1:(ri+1)*np,rj*np+1:(rj+1)*np,:);
    wc = [0.2126, 0.7152, 0.0722];
    subm = wc(1)*sub(:,:,1) + wc(2)*sub(:,:,2) + wc(3)*sub(:,:,3);
    subp = repmat(subm,3,3);
    
    s = 2;
    S = subp(np+i-(ri*np)-s:np+i-(ri*np)+s,np+j-(rj*np)-s:np+j-(rj*np)+s);
    [~,k] = max(reshape(S,(2*s+1)*(2*s+1),1));
    [si,sv] = ind2sub(2*s+1,k);
    u = i+si-s-1;
    v = j+sv-s-1;
else
    s = 2;
    S = mean(I(i-s:i+s,j-s:j+s),3);
    [~,k] = max(reshape(S,(2*s+1)*(2*s+1),1));
    [si,sv] = ind2sub(2*s+1,k);
    u = i+si-s-1;
    v = j+sv-s-1;
end;